%global service aodh

Summary:          OpenStack Telemetry Alarming
Name:             openstack-%{service}
Version:          12.0.0
Release:          2%{?dist}
License:          ASL 2.0
URL:              https://github.com/openstack/%{service}.git
Source0:          https://tarballs.openstack.org/%{service}/%{service}-%{version}.tar.gz
Source1:          %{service}-dist.conf
Source2:          %{service}.logrotate
Source3:         %{name}-api.service
Source4:         %{name}-evaluator.service
Source5:         %{name}-notifier.service
Source6:         %{name}-expirer.service
Source7:         %{name}-listener.service

BuildRequires:    python3-setuptools python3-devel systemd python3-pbr python3-sphinx python3-cotyledon python3-babel
BuildArch:        noarch

%description
Aodh is the alarm engine of the Ceilometer project.

%package          compat
Summary:          OpenStack %{service} compat
Requires:         python3-aodh
Requires:         %{name}-common %{name}-api %{name}-evaluator %{name}-notifier %{name}-expirer %{name}-listener
Provides:         openstack-ceilometer-alarm = %{version}-%{release}

%description      compat
This package only exists to help transition openstack-ceilometer-alarm users to the new package
split. It will be removed after one distribution release cycle, please do not reference it or depend
on it in any way.

%package -n       python3-%{service}
Summary:          OpenStack %{service} python libraries
Requires: python3-pytz python3-croniter python3-jsonschema python3-alembic python3-cachetools
Requires: python3-cotyledon python3-futurist python3-oslo-config python3-oslo-db python3-oslo-i18n
Requires: python3-oslo-log python3-oslo-policy python3-oslo-messaging python3-oslo-middleware
Requires: python3-oslo-upgradecheck python3-keystonemiddleware python3-pbr python3-pecan python3-stevedore
Requires: python3-sqlalchemy python3-requests python3-tenacity python3-tooz python3-webob python3-WSME
Requires: python3-dateutil python3-gnocchiclient python3-keystoneclient python3-heatclient
Requires: python3-keystoneauth1 python3-octaviaclient python3-debtcollector python3-voluptuous python3-pysnmp
Requires: python3-lxml python3-paste-deploy python3-oslo-context

%description -n   python3-%{service}
OpenStack %{service} provides API and services for managing alarms

This package contains the %{service} python library.

%package        common
Summary:        Components common to all OpenStack %{service} services
BuildRequires: python3-oslo-config python3-oslo-context python3-oslo-db python3-oslo-log python3-oslo-messaging
BuildRequires: python3-oslo-policy python3-oslo-reports python3-oslo-upgradecheck python3-oslo-vmware
BuildRequires: python3-glanceclient python3-heatclient python3-keystonemiddleware python3-neutronclient
BuildRequires: python3-novaclient python3-swiftclient python3-croniter python3-jsonpath-rw-ext python3-pecan
BuildRequires: python3-tooz python3-WSME python3-dateutil python3-gnocchiclient python3-octaviaclient
BuildRequires: python3-jsonpath-rw python3-lxml
Requires:       python3-aodh = %{version}-%{release} python3-oslo-utils
%{?systemd_requires}
Requires(pre):    shadow-utils

%description    common
OpenStack %{service} provides API and services for managing alarms

%package        api
Summary:        OpenStack %{service} API
Requires:       %{name}-common = %{version}-%{release}

%description api
OpenStack %{service} provides API and services for managing alarms

This package contains the %{service} API service.

%package        evaluator
Summary:        OpenStack %{service} evaluator
Requires:       %{name}-common = %{version}-%{release}

%description evaluator
OpenStack %{service} provides API and services for managing alarms

This package contains the %{service} evaluator service.

%package        notifier
Summary:        OpenStack %{service} notifier
Requires:       %{name}-common = %{version}-%{release}

%description notifier
OpenStack %{service} provides API and services for managing alarms

This package contains the %{service} notifier service.

%package        listener
Summary:        OpenStack %{service} listener
Requires:       %{name}-common = %{version}-%{release}

%description listener
OpenStack %{service} provides API and services for managing alarms

This package contains the %{service} listener service.

%package        expirer
Summary:        OpenStack %{service} expirer
Requires:       %{name}-common = %{version}-%{release}

%description expirer
OpenStack %{service} provides API and services for managing alarms

This package contains the %{service} expirer service.

%prep
%autosetup -n %{service}-%{version}

find . \( -name .gitignore -o -name .placeholder \) -delete

find %{service} -name \*.py -exec sed -i '/\/usr\/bin\/env python/{d;q}' {} +

sed -i '/setup_requires/d; /install_requires/d; /dependency_links/d' setup.py
sed -i '/python-ceilometerclient/d' requirements.txt
sed -i '/^\"PO-Revision-Date: \\n\"/d' %{service}/locale/*/LC_MESSAGES/*.po


%build
# fix oslo-config-generator fail due to python3-oslo-utils update
sed -i 's/from oslo_utils import fnmatch/import fnmatch/g' aodh/evaluator/event.py

PYTHONPATH=. oslo-config-generator --config-file=%{service}/cmd/%{service}-config-generator.conf --output-file=%{service}/%{service}.conf
%{py3_build}
%{__python3} setup.py compile_catalog -d build/lib/%{service}/locale --domain aodh
while read name eq value; do
  test "$name" && test "$value" || continue
  sed -i "0,/^# *$name=/{s!^# *$name=.*!#$name=$value!}" %{service}/%{service}.conf
done < %{SOURCE1}

%install
%{py3_install}

install -d -m 755 %{buildroot}%{_sysconfdir}/%{service}
install -p -D -m 640 %{SOURCE1} %{buildroot}%{_datadir}/%{service}/%{service}-dist.conf
install -p -D -m 640 %{service}/%{service}.conf %{buildroot}%{_sysconfdir}/%{service}/%{service}.conf

install -d -m 755 %{buildroot}%{_sharedstatedir}/%{service}
install -d -m 755 %{buildroot}%{_sharedstatedir}/%{service}/tmp
install -d -m 750 %{buildroot}%{_localstatedir}/log/%{service}

install -p -D -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}

install -p -D -m 644 %{SOURCE3} %{buildroot}%{_unitdir}/%{name}-api.service
install -p -D -m 644 %{SOURCE4} %{buildroot}%{_unitdir}/%{name}-evaluator.service
install -p -D -m 644 %{SOURCE5} %{buildroot}%{_unitdir}/%{name}-notifier.service
install -p -D -m 644 %{SOURCE6} %{buildroot}%{_unitdir}/%{name}-expirer.service
install -p -D -m 644 %{SOURCE7} %{buildroot}%{_unitdir}/%{name}-listener.service

install -d -m 755 %{buildroot}%{_datadir}
rm -f %{buildroot}%{python3_sitelib}/%{service}/locale/*/LC_*/%{service}*po
rm -f %{buildroot}%{python3_sitelib}/%{service}/locale/*pot
mv %{buildroot}%{python3_sitelib}/%{service}/locale %{buildroot}%{_datadir}/locale

%find_lang %{service} --all-name

rm -fr %{buildroot}/usr/etc

%pre common
getent group %{service} >/dev/null || groupadd -r %{service}
if ! getent passwd %{service} >/dev/null; then
  useradd -r -g %{service} -G %{service} -d %{_sharedstatedir}/%{service} -s /sbin/nologin -c "OpenStack %{service} Daemons" %{service}
fi
exit 0

%post -n %{name}-api
%systemd_post %{name}-api.service

%preun -n %{name}-api
%systemd_preun %{name}-api.service

%post -n %{name}-evaluator
%systemd_post %{name}-evaluator.service

%preun -n %{name}-evaluator
%systemd_preun %{name}-evaluator.service

%post -n %{name}-notifier
%systemd_post %{name}-notifier.service

%preun -n %{name}-notifier
%systemd_preun %{name}-notifier.service

%post -n %{name}-listener
%systemd_post %{name}-listener.service

%preun -n %{name}-listener
%systemd_preun %{name}-listener.service

%post -n %{name}-expirer
%systemd_post %{name}-expirer.service

%preun -n %{name}-expirer
%systemd_preun %{name}-expirer.service

%files compat

%files -n python3-%{service}
%license LICENSE
%{python3_sitelib}/%{service}
%{python3_sitelib}/%{service}-*.egg-info

%files common -f %{service}.lang
%doc README.rst
%dir %{_sysconfdir}/%{service}
%attr(-, root, %{service}) %{_datadir}/%{service}/%{service}-dist.conf
%config(noreplace) %attr(-, root, %{service}) %{_sysconfdir}/%{service}/%{service}.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%dir %attr(0750, %{service}, root)  %{_localstatedir}/log/%{service}
%{_bindir}/%{service}-dbsync
%{_bindir}/%{service}-config-generator
%{_bindir}/%{service}-status

%defattr(-, %{service}, %{service}, -)
%dir %{_sharedstatedir}/%{service}
%dir %{_sharedstatedir}/%{service}/tmp

%files api
%{_unitdir}/%{name}-api.service
%{_bindir}/%{service}-api

%files evaluator
%{_unitdir}/%{name}-evaluator.service
%{_bindir}/%{service}-evaluator

%files notifier
%{_unitdir}/%{name}-notifier.service
%{_bindir}/%{service}-notifier

%files listener
%{_unitdir}/%{name}-listener.service
%{_bindir}/%{service}-listener

%files expirer
%{_unitdir}/%{name}-expirer.service
%{_bindir}/%{service}-expirer

%changelog
* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 12.0.0-2
- Rebuilt for OpenCloudOS Stream 23.05

* Thu Apr 13 2023 Shuo Wang <abushwang@tencent.com> - 12.0.0-1
- initial build
